
| Feature/Client             | [emacs-ccls]    | [vscode-ccls] | [atom-ide-ccls] | [eglot]   |[coc.nvim]|[LanguageClient-neovim]|[ale]          |[vim-lsp]      |[vim-lsc]      |
| -------------------------- | --------------- | ------------- | --------------- | --------- |----------|-----------------------|---------------|---------------|---------------|
| hover                      | ✓               | ✓             | ✓               | ✓         |✓         |✓                      |✓              |✓              |✓              |
| Diagnostics                | ✓               | ✓             | ✓               | flymake   |✓         |✓                      |✓              |✓              |✓              |
| documentHighlight          | ✓               | ✓             | ✓               | ✓         |✓         |✓                      |               |✓              |✓              |
| signatureHelp              | echo area       | dropdown      | ✓               | echo area |✓         |✓                      |               |✓              |✓              |
| snippets                   | ✓               | ✓             | ✓               | ✓         |✓         |with [vim-vsnip]       |               |with [vim-vsnip]|with [vim-vsnip]|
| codeLens                   | ✓               | ✓             | ✓               |           |✓         |✓                      |               |✓              |               |
| onTypeFormatting           | ✓               | ✓             | ✓               |           |✓         |                       |               |               |               |
| semanticHighlight          | ✓               | ✓             | ✓               |           |with [vim-lsp-cxx-highlight]|with [vim-lsp-cxx-highlight]|               |with [vim-lsp-cxx-highlight]|               |
| Custom Location[] requests | ✓               | Partial       |                 |           |✓         |✓                      |               |               |               |
| Hierarchical Symbol        | ✓               | ✓             | ✓               |           |✓         |with [vim-ccls]        |with [vim-ccls]|with [vim-ccls]|with [vim-ccls]|

- Atom IDE: [atom-ide-ccls]
- Emacs: [eglot] [emacs-ccls]
- (Neo)Vim: [coc.nvim] [ale] [LanguageClient-neovim] [vim-lsp] [vim-lsc]
- VSCode: [vscode-ccls]
- Monaco Editor: [monaco-editor]

### Custom `Location[]` requests

ccls supports many cross reference extensions (requests that return `Location[]` like `textDocument/definition`), see
https://github.com/MaskRay/ccls/wiki/FAQ#definitions and following sections.

[ale]: https://github.com/w0rp/ale
[coc.nvim]: https://github.com/neoclide/coc.nvim
[eglot]: https://github.com/joaotavora/eglot
[emacs-ccls]: https://github.com/MaskRay/emacs-ccls
[atom-ide-ccls]: https://github.com/isundaylee/atom-ide-ccls
[LanguageClient-neovim]: https://github.com/autozimu/LanguageClient-neovim
[lsp-mode]: https://github.com/emacs-lsp/lsp-mode
[vim-lsp]: https://github.com/prabirshrestha/vim-lsp
[vim-lsc]: https://github.com/natebosch/vim-lsc
[vim-ccls]: https://github.com/m-pilia/vim-ccls
[vscode-ccls]: https://github.com/MaskRay/vscode-ccls
[monaco-editor]: https://github.com/MaskRay/ccls/wiki/Monaco-Editor
[vim-vsnip]: https://github.com/hrsh7th/vim-vsnip
[vim-lsp-cxx-highlight]: https://github.com/jackguo380/vim-lsp-cxx-highlight