Install [YouCompleteMe](https://github.com/ycm-core/YouCompleteMe)

```sh
cd ~/.vim/bundle/YouCompleteMe
./install.py  # --clang-completer is not needed
```

## Configure

```vim
let g:ycm_language_server =
  \ [{
  \   'name': 'ccls',
  \   'cmdline': [ 'ccls' ],
  \   'filetypes': [ 'c', 'cpp', 'cuda', 'objc', 'objcpp' ],
  \   'project_root_files': [ '.ccls-root', 'compile_commands.json' ]
  \ }]
```

## Cross references

```vim
:YcmCompleter GoToDefinition
:YcmCompleter GoToDeclaration
:YcmCompleter GoToReferences
:YcmCompleter GoToImplementation
:YcmCompleter GoToType
```
