Install [nvim-lspconfig](https://github.com/neovim/nvim-lspconfig) according to the instructions in its README.

<https://github.com/neovim/nvim-lspconfig/blob/master/lua/lspconfig/server_configurations/ccls.lua> has a built-in rule for ccls.
You can customize initialization options with:

```lua
local lspconfig = require('lspconfig')
lspconfig.ccls.setup {
  init_options = {
    cache = {
      directory = ".ccls-cache";
    };
  }
}
```
